#ifndef PED_FILESYSTEMTYPE_H
#define PED_FILESYSTEMTYPE_H

#include "device.h"

namespace Ped {

    class FileSystemType {

        friend class FileSystem;
        friend class Partition;

        private:
        FileSystemType( );
        FileSystemType(const PedFileSystemType *fst);
        FileSystemType(const FileSystemType &fst);
        FileSystemType& operator=(const FileSystemType &fst);

        const PedFileSystemType* get_c_file_system_type ( ) const;
        PedFileSystemType*       get_c_file_system_type ( );

        PedFileSystemType              *fs_type_;
        std::auto_ptr<FileSystemType>   fstype_;

        public:
        // ped_file_system_type_get()
        FileSystemType                                  (std::string &name);
        // destructor
        ~FileSystemType                                 ( );
        //  ped_file_system_type_get_next()
        FileSystemType&          get_next               ( ) throw (std::runtime_error);
        const std::string        get_name               ( ) const;

        protected:

    };

};

#endif

/* vim: set tabstop=4 et shiftwidth=4: */
